MeteorWrapperLdapjs = Npm.require 'ldapjs'

Meteor.startup ->
	RocketChat.settings.addGroup 'LDAP'
	RocketChat.settings.add 'LDAP_Enable', false    , { type: 'boolean', group: 'LDAP', i18nLabel: 'rocketchat-ldap:LDAP_Enable', public: true }
	RocketChat.settings.add 'LDAP_Url'   , 'ldap://', { type: 'string' , group: 'LDAP', i18nLabel: 'rocketchat-ldap:LDAP_Url' }
	RocketChat.settings.add 'LDAP_Port'  , '389'    , { type: 'string' , group: 'LDAP', i18nLabel: 'rocketchat-ldap:LDAP_Port' }
	RocketChat.settings.add 'LDAP_DN'    , ''       , { type: 'string' , group: 'LDAP', i18nLabel: 'rocketchat-ldap:LDAP_Dn', public: true }


timer = undefined
updateServices = ->
	Meteor.clearTimeout timer if timer?

	timer = Meteor.setTimeout ->
		enable = Settings.findOne({_id: 'LDAP_Enable', value: true})

		if enable?
			console.log "Enabling LDAP".blue
			LDAP_DEFAULTS.url = RocketChat.settings.get 'LDAP_Url'
			LDAP_DEFAULTS.port = RocketChat.settings.get 'LDAP_Port' if RocketChat.settings.get 'LDAP_Port'
			LDAP_DEFAULTS.dn = RocketChat.settings.get 'LDAP_DN' or false
		else
			LDAP_DEFAULTS.url = undefined
			LDAP_DEFAULTS.port = undefined
			LDAP_DEFAULTS.dn = undefined
	, 2000

Settings.find().observe
	added: (record) ->
		if /^LDAP_.+/.test record._id
			updateServices()

	changed: (record) ->
		if /^LDAP_.+/.test record._id
			updateServices()

	removed: (record) ->
		if /^LDAP_.+/.test record._id
			updateServices()